#
# Program to contruct a constant from an elf disassembly
# first dissasemble theelf file something like:
# pic32-objdump -d  plug.elf > dis.txt

import sys, os

# Extracts the opcodes from the specified function and returns with them in a
# list, just use name of function, e.g. main this becomes <main>:
def get_ops(inName,function):
    out = []
    fname = "<"+function+">:"
    inF = open(inName, 'r').readlines()
    # get to the start of the required function
    for i in range(len(inF)):
        if inF[i].find(fname) > 0:
            break
    if i < len(inF):  # function found
        for j in range(i+1,len(inF)):
           op = inF[j].split()
           if len(op) < 2:  # blank line is end of routine
                break; # all done
           else:
                out.append(op[1])
    return out

# creates a file from the supplied list of opcodes
def create_const(inFile,outFile,function):
    count = 2
    ops = get_ops(inFile,function)
    outF = open(outFile, 'w')
    outF.write("constant {0} ".format(function))
    outF.write("{ ");
    for i in range(0,len(ops)):
        # last one
        if i == len(ops)-1:
            outF.write("0x{0} ".format(ops[i]))
            outF.write("} \n")
            break
        outF.write("0x{0}, ".format(ops[i]))
        count+=1
        if count > 5:
            count = 0
            outF.write("\\ \n")
    outF.close()
    
def main():
    if len(sys.argv) < 3:
        print "usage: distobas <disassembly file> <output file>"
        return
    print "Using {0} to create {1}".format(sys.argv[1],sys.argv[2])
    os.system('pic32-objdump -d  plugin.elf > dis.txt')
    create_const('dis.txt',sys.argv[2]+".bas",sys.argv[2])

if __name__ == "__main__":
    main()