/* Notes
	A plug in must not call a function, even a built in function. This will then make
	it relocatable and can be used in any ByPic project at any position. If a function
	is called this not only increases the complexity but will make it very specific to
	a device and release.
	A plug in requires a data location to be passed and will always return an integer.
	
	When the plugin is built, the .elf file along with pic32-objdump is used to produce a 
	disassembly of the code, this is placed in 'dis.tst'. The opcodes are taken from that 
	file are put in a constant {} data statement ready for the ByPic to use.
	
	This could be done manually but there is a A Python program called distobasX.py (X is a number) 
	that does this automatically. It will create 'dis.txt', parse it and output a file called 'plugin.bas'
	
	Compiler options: -mlong-calls -fPIC -mno-gpopt -mshared -mno-abicalls
*/

// This simple plugin will take 2 integers, multiply them together and return
// the result
int test1_pi(char *c)
{
int *ip, a, b;
	ip = (int*)c; // convenent integer pointer
	a = *(ip); // contents of memory as integer
	b = *(ip+1); // contents of memory as integer
    return (a * b);
}

// as test 1 but add
int test2_pi(char *c)
{
int *ip, a, b;
	ip = (int*)c; // convenent integer pointer
	a = *(ip); // contents of memory as integer
	b = *(ip+1); // contents of memory as integer
    return (a + b);
}


// C programs need main()	
void main() {}

